%global	gem_name	gobject-introspection
%global	gem_so_name	gobject_introspection
%global	rubyabi	1.9.1

%global	glib_min_ver	1.2.1

Summary:	Ruby binding of GObjectIntrospection
Name:		rubygem-%{gem_name}
Version:	1.2.1
Release:	1%{?dist}

Group:		Development/Languages
# lib/gobject-introspection.rb and so on
License:	LGPLv2+
URL:		http://ruby-gnome2.sourceforge.jp/
Source0:	http://rubygems.org/gems/%{gem_name}-%{version}.gem

Requires:	ruby(abi) = %{rubyabi}
Requires:	ruby(rubygems) 
Requires:	ruby
Requires:	rubygem(glib2)
BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	rubygems-devel 
BuildRequires:	rubygem-glib2-devel >= %{glib_min_ver}
BuildRequires:	gobject-introspection-devel
# %%check
BuildRequires:	rubygem(test-unit)
BuildRequires:	rubygem(test-unit-notify)
Provides:	rubygem(%{gem_name}) = %{version}-%{release}

%description
Ruby/GObjectIntrospection is a Ruby binding of 
GObjectIntrospection.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}
BuildArch:	noarch

%description	doc
Documentation for %{name}

%prep
%setup -q -c -T

TOPDIR=$(pwd)
mkdir tmpunpackdir
pushd tmpunpackdir

gem unpack %{SOURCE0}
cd %{gem_name}-%{version}

# Permission
find . -name \*.rb -print0 | xargs --null chmod 0644

# For old test-unit (2.4.5)
sed -i \
	-e 's|^\(require "test-unit"\)$|gem "test-unit"\nrequire "test/unit"|' \
	test/gobject-introspection-test-utils.rb

gem specification -l --ruby %{SOURCE0} > %{gem_name}.gemspec
gem build %{gem_name}.gemspec
mv %{gem_name}-%{version}.gem $TOPDIR

popd
rm -rf tmpunpackdir

%build
mkdir -p .%{gem_dir}

export CONFIGURE_ARGS="--with-cflags='%{optflags} -Werror-implicit-function-declaration'"
export CONFIGURE_ARGS="$CONFIGURE_ARGS --with-pkg-config-dir=$(pwd)%{_libdir}/pkgconfig"
gem install \
	--local \
	--install-dir .%{gem_dir} \
	-V \
	--force \
	%{gem_name}-%{version}.gem

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
	%{buildroot}%{gem_dir}/

# move header files, C extension files to the correct directory
pushd %{buildroot}

mkdir -p .%{gem_extdir}/lib
mv .%{gem_instdir}/lib/%{gem_so_name}.so .%{gem_extdir}/lib/
popd

# move pkgconfig file
#mkdir %%{buildroot}%%{_libdir}/pkgconfig
#install -cpm 644 ./%%{_libdir}/pkgconfig/*.pc \
#	%%{buildroot}%%{_libdir}/pkgconfig/

# Cleanups
pushd %{buildroot}
rm -rf .%{gem_instdir}/ext/
rm -f .%{gem_instdir}/extconf.rb
popd

%check
pushd .%{gem_instdir}

# Kill unneeded make process
mkdir -p TMPBINDIR
pushd TMPBINDIR
ln -sf /bin/true make
export PATH=$(pwd):$PATH
popd

ruby -Ilib:test ./test/run-test.rb || \
	echo "Please investigate this"
popd

%files
%dir	%{gem_instdir}/
%dir	%{gem_instdir}/lib/
%{gem_instdir}/lib/%{gem_name}.rb
%dir	%{gem_instdir}/lib/%{gem_name}/
%{gem_instdir}/lib/%{gem_name}/*.rb

%dir	%{gem_extdir}/
%dir	%{gem_extdir}/lib/
%{gem_extdir}/lib/%{gem_so_name}.so

%exclude %{gem_cache}
%{gem_spec}

%files		doc
%doc	%{gem_docdir}/
%exclude	%{gem_instdir}/Rakefile
%exclude	%{gem_instdir}/test/

%changelog
* Mon Feb 11 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.1-1
- 1.2.1

* Sat Jan 05 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.1.9-1
- Initial package
